/*
*
* Copyright (c) 2005 Sun Microsystems, Inc.
* All rights reserved.
* You may not modify, use, reproduce, or distribute this software except in compliance with the terms
* of the License at: http://developer.sun.com/berkeley_license.html
* Author : Sameer Tyagi, Sun Microsystems s.t@sun.com
* "Realizing Strategies for Document-Based Web Services With JAX-WS 2.0"
*  http://java.sun.com/developer/technicalArticles/xml/jaxrpcpatterns
*/
package com.examples.docliteral;

import java.rmi.RemoteException;
import java.util.Date;
import java.util.List;
// import generated types
import com.examples.types.po.*;
import com.examples.types.poproblem.*;
import com.examples.types.postatus.*;

@javax.jws.WebService(endpointInterface="com.examples.docliteral.IPurchaseOrder")
public class PurchaseOrderService{

    public PurchaseOrderStatus acceptPO(PurchaseOrder order) throws ProcessingFault {
        if (order == null) {
            throw  new ProcessingFault("Web Service was passed a null Purchase order",new POProcessingProblem());
        } else if (order.getItems() == null ||
                order.getPoID() == null ||
                order.getBillTo() == null) {
            throw new ProcessingFault("Purcahse order cannot have null fields", new POProcessingProblem());
        }
        System.out.println("PurchaseOrder received in the web service");
        System.out.println("Order ID " + order.getPoID());
        System.out.println("Order creation date " + order.getCreateDate());
        System.out.println("Ship To Address " + order.getShipTo());
        System.out.println("Bill To Address " + order.getBillTo());
        System.out.println("Order Contents :");
        List<LineItem> items = order.getItems();
        for (int i = 0; i < items.size(); i++)
            System.out.println(items.get(i));

        PurchaseOrderStatus status = new PurchaseOrderStatus();
        status.setTimestamp(new Date().toString());
        status.setOrderid("ABC" + System.currentTimeMillis());
        return status;

    }


}
